<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="650px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
<el-form ref="formRef" :model="formData" label-width="120px" :rules="formRules">
<el-form-item label="产品ID" prop="id">
    <el-input v-model="formData.id" disabled clearable placeholder="请输入产品ID" />
</el-form-item>
<el-form-item label="产品名称" prop="name">
                    <el-input
                        v-model="formData.name"
                        disabled
                        clearable
                        placeholder="请输入产品名称"
                    />
</el-form-item>
<el-form-item label="绑定设备" prop="device_id">
    <el-select
        v-model="formData.device_id"
        filterable
        multiple
        remote
        reserve-keyword
        placeholder="请输入设备信息"
        :remote-method="queryDevice"
        :loading="loading"
      >
        <el-option
          v-for="(item, index) in optionsData.device"
          :key="index"
        :label="item.deviceinfo"
        :value="item.id"
        />
      </el-select>
</el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="landEdit">
import { useDictOptions } from '@/hooks/useDictOptions'
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiProductBind, apiDeviceLists } from '@/api/product'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return (mode.value = '绑定设备')
})

// 表单数据
const formData = reactive({
    id: '',
    name: '',
    device_id: ''
})

// 表单验证
const formRules = reactive<any>({
    device_id: [{
        required: true,
        message: '请选择绑定设备',
        trigger: ['blur']
    }],
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const { optionsData } = useDictOptions<{
    device: any[]
}>({
    device: {
        api: apiDeviceLists
    }
})

const loading = ref(false)

const queryDevice = async (query: string) => {
    loading.value = true
    const deviceList = await apiDeviceLists({
        name: query ?? ''
    })
    optionsData.device = deviceList
    loading.value = false
}

// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    await apiProductBind(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}


defineExpose({
    open,
    setFormData
})
</script>
